﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace KbdLEDs
{
    public partial class MainForm : Form
    {
        private LED[] btnStrips = (LED[])Enum.GetValues(typeof(LED)); 

        public MainForm()
        {
            InitializeComponent();
            timerUpdateIndicators.Enabled = true;
        }

        private void UpdateIndicators()
        {
            labelNum.BackColor = LEDs.GetToggleState(LED.NumLock) ? Color.GreenYellow : Color.Silver;
            labelCaps.BackColor = LEDs.GetToggleState(LED.CapsLock) ? Color.GreenYellow : Color.Silver;
            labelScroll.BackColor = LEDs.GetToggleState(LED.ScrollLock) ? Color.GreenYellow : Color.Silver;
        }

        private void buttonToggle_Click(object sender, EventArgs e)
        {
            LEDs.Toggle(btnStrips[int.Parse((((Button)sender).Tag).ToString())]);
        }

        private void buttonSet_Click(object sender, EventArgs e)
        {
            LEDs.SetToggleState(btnStrips[int.Parse((((Button)sender).Tag).ToString())], true);
        }

        private void buttonReset_Click(object sender, EventArgs e)
        {
            LEDs.SetToggleState(btnStrips[int.Parse((((Button)sender).Tag).ToString())], false);
        }

        private void buttonShortImp_Click(object sender, EventArgs e)
        {
            LEDs.Impulse(btnStrips[int.Parse((((Button)sender).Tag).ToString())], 150);
        }

        private void buttonLongImp_Click(object sender, EventArgs e)
        {
            LEDs.Impulse(btnStrips[int.Parse((((Button)sender).Tag).ToString())], 1500);
        }

        private void timerUpdateIndicators_Tick(object sender, EventArgs e)
        {
            UpdateIndicators();
        }

        private void buttonClose_Click(object sender, EventArgs e)
        {
            Close();
        }

    }
}
