﻿using System;
using System.Windows.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace KbdLEDs
{
    /// <summary>
    /// Test for KbdLEDs.dll
    /// JoAchim Berg 2014, Hamburg, Germany, achim_berg_de@yahoo.com
    /// </summary>
    public partial class MainWindow : Window
    {
        LinearGradientBrush greenBrush = new LinearGradientBrush(Colors.GreenYellow, Colors.Lime, 90.0);
        LinearGradientBrush grayBrush = new LinearGradientBrush(Colors.Silver, Colors.DimGray, 90.0);
        DispatcherTimer updateTimer; // polling toggle states for indicators
        private LED[] btnStrips = (LED[])Enum.GetValues(typeof(LED));

        public MainWindow()
        {
            InitializeComponent();
            updateTimer = new DispatcherTimer(TimeSpan.FromMilliseconds(100), 
                DispatcherPriority.Background, updateIndicators, Application.Current.Dispatcher);
        }

        //-----------------------------------------------------------------

        private void BtnToggle_Click(object sender, RoutedEventArgs e)
        {
            LEDs.Toggle(btnStrips[int.Parse((((Button)sender).Tag).ToString())]);
        }

        private void BtnSet_Click(object sender, RoutedEventArgs e)
        {
            LEDs.SetToggleState(btnStrips[int.Parse((((Button)sender).Tag).ToString())], true);
        }

        private void BtnReset_Click(object sender, RoutedEventArgs e)
        {
            LEDs.SetToggleState(btnStrips[int.Parse((((Button)sender).Tag).ToString())], false);
        }

        private void BtnImpShort_Click(object sender, RoutedEventArgs e)
        {
            LEDs.Impulse(btnStrips[int.Parse((((Button)sender).Tag).ToString())], 150);
        }

        private void BtnImpLong_Click(object sender, RoutedEventArgs e)
        {
            LEDs.Impulse(btnStrips[int.Parse((((Button)sender).Tag).ToString())], 1500);
        }

        //-----------------------------------------------------------------

        private void updateIndicators(object sender, EventArgs e)
        {
            NumIndicator.Fill = LEDs.GetToggleState(KbdLEDs.LED.NumLock) ? greenBrush : grayBrush;
            CapsIndicator.Fill = LEDs.GetToggleState(KbdLEDs.LED.CapsLock) ? greenBrush : grayBrush;
            ScrollIndicator.Fill = LEDs.GetToggleState(KbdLEDs.LED.ScrollLock) ? greenBrush : grayBrush;
        }

        private void BtnClose_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

    }
}
